#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

#include "queue.h"

void
queue_init (struct queue* q, int size)
{
  q->N = size;
  q->buf = malloc (sizeof (int) * size);
  q->begin = 0;
  q->end = 0;
  // TODO: initialize synchronization primitives
}

void
queue_free (struct queue* q)
{
  free (q->buf);
  q->buf = NULL;
}

// TODO: For each of the following methods, add appropriate
// synchronization mechanisms

void
queue_add (struct queue* q, int val)
{
  q->buf[++q->end % q->N] = val;
  fprintf(stderr, "added %d\n", val);
}

int
queue_remove (struct queue* q)
{
  int val;
  val = q->buf[++q->begin % q->N];
  fprintf(stderr, "removed %d\n", val);
  return val;
}

int
queue_peek (struct queue* q)
{
  int val;
  val = q->buf[(q->begin + 1) % q->N];
  return val;
}
